package exnihilocreatio.items;

import exnihilocreatio.ExNihiloCreatio;
import exnihilocreatio.ModItems;
import exnihilocreatio.blocks.BlockInfestedLeaves;
import exnihilocreatio.util.Data;
import exnihilocreatio.util.IHasModel;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;
import java.util.ArrayList;

public class ItemResource extends Item implements IHasModel {

    public static final String PORCELAIN_CLAY = "porcelain_clay";
    public static final String SILKWORM = "silkworm";
    public static final String ANCIENT_SPORES = "ancient_spores";
    public static final String GRASS_SEEDS = "grass_seeds";
    public static final String DOLL_BASE = "doll";
    public static final String ROD_STONE = "rod_stone";
    public static final String GEAR_STONE = "gear_stone";

    private static ArrayList<String> names = new ArrayList<String>();

    public ItemResource() {
        super();

        func_77637_a(ExNihiloCreatio.tabExNihilo);
        func_77655_b("item_material");
        setRegistryName("item_material");
        func_77627_a(true);
        Data.ITEMS.add(this);

        names.add(0, "removed");
        names.add(1, PORCELAIN_CLAY);
        names.add(2, SILKWORM);
        names.add(3, ANCIENT_SPORES);
        names.add(4, GRASS_SEEDS);
        names.add(5, DOLL_BASE);
        names.add(6, ROD_STONE);
        names.add(7, GEAR_STONE);
    }

    public static ItemStack getResourceStack(String name) {
        return getResourceStack(name, 1);
    }

    public static ItemStack getResourceStack(String name, int quantity) {
        return new ItemStack(ModItems.resources, quantity, names.indexOf(name));
    }

    public static int getMetaFromName(String name) {
        return names.indexOf(name);
    }

    @Override
    @Nonnull
    public String func_77667_c(ItemStack stack) {
        return func_77658_a() + "." + names.get(stack.func_77952_i());
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_150895_a(@Nonnull CreativeTabs tab, NonNullList<ItemStack> list) {
        if (this.func_194125_a(tab))
            for (int i = 1; i < names.size(); i++) {
                list.add(new ItemStack(this, 1, i));
            }
    }

    @Override
    @Nonnull
    public EnumActionResult func_180614_a(EntityPlayer player, World world, BlockPos pos, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
        ItemStack stack = player.func_184586_b(hand);

        if (stack.func_77952_i() == names.indexOf(SILKWORM)) {
            IBlockState state = world.func_180495_p(pos);
            if (state != Blocks.field_150350_a.func_176223_P() && state.func_177230_c() != Blocks.field_150350_a && (state.func_177230_c() == Blocks.field_150362_t || state.func_177230_c() == Blocks.field_150361_u)) {
                BlockInfestedLeaves.infestLeafBlock(world, pos);
                stack.func_190918_g(1);

                return EnumActionResult.SUCCESS;
            }
        }
        if (stack.func_77952_i() == names.indexOf(ANCIENT_SPORES) || stack.func_77952_i() == names.indexOf(GRASS_SEEDS)) {
            IBlockState state = world.func_180495_p(pos);
            if (state != Blocks.field_150350_a.func_176223_P() && state.func_177230_c() != Blocks.field_150350_a && state.func_177230_c() == Blocks.field_150346_d) {
                IBlockState transformTo = stack.func_77952_i() == names.indexOf(ANCIENT_SPORES) ? Blocks.field_150391_bh.func_176223_P() : Blocks.field_150349_c.func_176223_P();
                world.func_175656_a(pos, transformTo);
                stack.func_190918_g(1);

                return EnumActionResult.SUCCESS;
            }
        }

        return EnumActionResult.PASS;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void initModel(ModelRegistryEvent e) {
        for (int i = 0; i < names.size(); i++) {
            String variant = "type=" + names.get(i);

            ModelLoader.setCustomModelResourceLocation(this, i, new ModelResourceLocation(getRegistryName(), variant));
        }
    }

}
